#include "include/terminal_api/ControlProtoCInterface.h"
#include <iostream>
int main()
{
    TSID sid{0};
    unsigned int access{0};
    if(CP_Login("admin","pass",&sid,&access) == OK)
    {
       std::cout << "Succsec" << std::endl;
    }
    CinC_state state_cinc;
    state_cinc.carrier_lock = false;
    CP_GetCinCState(sid,state_cinc);
    std::cout << state_cinc.carrier_lock << std::endl;
    std::cout << state_cinc.freq_error_offset << std::endl;
    std::cout << state_cinc.delay_dpdi << std::endl;
    std::cout << state_cinc.cnt_bad_lock << std::endl;
    modulator_state modulator;
    CP_GetModulatorState(sid, modulator);
    std::cout << modulator.is_pilots << "\n"
    <<  modulator.modcod << "\n"
    <<  modulator.snr_remote << "\n";
    demodulator_state demodulator;
    demodulator.dummy_cnt = 11111;
    CP_GetDemodulatorState(sid, demodulator);
    std::cout << "end CP_GetDemodulatorState" << std::endl;
    std::cout << demodulator.is_short << std::endl;
    std::cout << demodulator.modcod << std::endl;
    std::cout << "afc_lock: " <<demodulator.locks.afc_lock << std::endl;
    std::cout << "sym_sync_lock: " <<demodulator.locks.sym_sync_lock << std::endl;
    std::cout << "freq_lock: " <<demodulator.locks.freq_lock << std::endl;
    std::cout << "pkt_sync: " << demodulator.locks.pkt_sync << std::endl;
    modulator_settings setting_modulator;
    setting_modulator.baudrate = 2000000;
    setting_modulator.central_freq_in_kGz = 1340000.24;
    setting_modulator.rollof = 0.25;
    setting_modulator.tx_is_on = true;
    setting_modulator.is_test_data = false;
    setting_modulator.is_save_current_state = true;
    setting_modulator.is_cinc = false;
    setting_modulator.is_carrier = true;
    CP_SetModulatorSettings(sid, setting_modulator);
    demodulator_settings demodulator_sett;
    demodulator_sett.baudrate = 1340000;
    demodulator_sett.central_freq_in_kGz = 2400000.34;
    demodulator_sett.is_rvt_iq = true;
    demodulator_sett.is_aru_on = true;
    demodulator_sett.gain = 13;
    demodulator_sett.rollof = 0.15;
    if(CP_SetDemodulatorSettings(sid, demodulator_sett)== OK)
    {
        std::cout << "OK SET DEMODULATOR SETTINGS" <<  std::endl;
    }
    demodulator_settings demodulator_settings_;
    if(CP_GetDemodulatorSettings(sid,demodulator_settings_) == OK)
    {
        std::cout << "OK GET DEMODULATOR SETTINGS" << std::endl;
        std::cout << demodulator_settings_.baudrate << std::endl;
        std::cout << demodulator_settings_.gain<< std::endl;
        std::cout << demodulator_settings_.rollof << std::endl;
        std::cout << demodulator_settings_.is_aru_on << std::endl;
        std::cout << demodulator_settings_.is_rvt_iq << std::endl;
        std::cout << demodulator_settings_.central_freq_in_kGz << std::endl;
    }
    modulator_settings modulator_settings_;
    if(CP_GetModulatorSettings(sid,modulator_settings_)== OK)
    {
        std::cout << "OK GET MODULATOR SETTINGS" << std::endl;
        std::cout << modulator_settings_.baudrate << std::endl;
        std::cout << modulator_settings_.attenuation << std::endl;
        std::cout << modulator_settings_.central_freq_in_kGz << std::endl;
        std::cout << modulator_settings_.is_carrier << std::endl;
        std::cout << modulator_settings_.is_cinc << std::endl;
        std::cout << modulator_settings_.rollof << std::endl;
    }
}
